﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace cv06
{
    public partial class Form1 : Form
    {
        private Form formAbout;
        public Form1()
        {
            InitializeComponent();
            //Soubor resource musi byt nastaven na generovani kodu.
            l_resource.Text = MyResource.Whatever;
            //namespace: System.Configuration. Nekdy je treba pripojit knihovnu do referenci.
            l_config.Text = ConfigurationManager.AppSettings["myString"];

            pictureBox1.AllowDrop = true;
            pictureBox2.AllowDrop = true;
        }

        private void b_name_Click(object sender, EventArgs e)
        {
            using (var formName = new FormName())
            {
                //Modalni okno (blokujici)
                if (formName.ShowDialog() == DialogResult.OK)
                {
                    tb_name.Text = formName.MyName;
                }
            }
        }

        private void b_form_Click(object sender, EventArgs e)
        {
            //Nemodalni okno (blokujici)
            if (formAbout != null)
            {
                formAbout.Close();
                formAbout.Dispose();
            }
            formAbout = new FormAbout();
            formAbout.Show();
        }

        private void b_send_Click(object sender, EventArgs e)
        {
            errorProvider1.Clear();
            ValidateTextBox(textBox1);
            ValidateTextBox(textBox2);
        }

        //TextBox se validuje když ztratí focus
        private void textBox_Validating(object sender, CancelEventArgs e)
        {
            ValidateTextBox(sender as TextBox);
        }

        private void ValidateTextBox(TextBox tb)
        {
            if (string.IsNullOrWhiteSpace(tb.Text))
                errorProvider1.SetError(tb, "Prazdny text box");
        }

        private void b_clipboard_Click(object sender, EventArgs e)
        {
            tb_clipboard.Text = Clipboard.GetText();
        }

        private void pictureBox1_DragDrop(object sender, DragEventArgs e)
        {
            //Ze souboru
            var container = e.Data.GetFormats();
            pictureBox1.Image = new Bitmap(((IEnumerable<string>)e.Data.GetData("FileName")).First());
        }

        private void pictureBox2_DragDrop(object sender, DragEventArgs e)
        {
            //Vramci programu
            var container = e.Data.GetFormats();
            if (e.Data.GetFormats().Contains(DataFormats.Bitmap))
            {
                pictureBox2.Image = (Image)e.Data.GetData(DataFormats.Bitmap);
            }
        }

        private void pictureBox_DragEnter(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.Copy;
        }

        private void pictureBox_MouseDown(object sender, MouseEventArgs e)
        {
            PictureBox pb = sender as PictureBox;
            if (pb?.Image != null)
            {
                pb.DoDragDrop(pb.Image, DragDropEffects.Copy);
            }
        }

        //Do Work se provede v inem vlaknu nez je UI Formy
        //NIKDY NEMENIT UI Z JINEHO VLAKNA NEZ Z UI VLAKNA!!!
        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            for (int i = 1; i <= 100; i++)
            {
                Thread.Sleep(200); // Narocna operace v jinem vlaknu
                backgroundWorker1.ReportProgress(i);
            }
        }

        //Provede se ve vlaknu UI Formy
        private void backgroundWorker1_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            progressBar1.Value = e.ProgressPercentage;
        }

        //Provede se ve vlaknu UI Formy
        private void backgroundWorker1_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            MessageBox.Show("Hotovo");
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            backgroundWorker1.RunWorkerAsync();
        }
    }
}
